<?php
namespace App\Controller;
 
use App\Entity\Product;
use App\Repository\CartRepository;
use App\Repository\CategoryRepository;
use App\Repository\ProductRepository;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
class StaticPages extends AbstractController
{
    /**
     * @Route("/", name="home")
     */
    public function home(CategoryRepository $categoryRepository, ProductRepository $productRepository, Request $request): Response
    {
        $categoryId = $request->query->get('category');

        if ($categoryId) {
            $category = $categoryRepository->find($categoryId);
            $products = $category->getProducts();
            $categoryName = $category->getName();
        } else {
            $products = $productRepository->findAll();
            $categoryName = null;
        }
    
        return $this->render('home.html.twig', [
            'categories' => $categoryRepository->findAll(),
            'products' => $products,
            'categoryName' => $categoryName,
        ]);
    }
    

    #[Route('/product/{id}', name: 'app_product_show', methods: ['GET'])]
    public function show(CartRepository $cartRepository, Product $product): Response
    {
        $count = $cartRepository->countProductInCart($product->getId());

        return $this->render('product/show.html.twig', [
            'product' => $product,
            'count' => $count,
        ]);
    }

}